/**
 * Created by xueyang on 2016/11/21.
 */



    var whichTemplate = $('meta[name=itemTemplate]').attr('content');
    function loadScroller(){
		setTimeout(
        	function(){
        		commonScroll('#content','#add', whichTemplate);
        	},
        150);
    }
    function commonScroll(el,listID,itemTemplate){
        var scrollWrapper = el;
        var listElement = $(listID);
        var myScroll;
        var pullDownEl;
        var pullDownL;
        var pullUpEl;
        var pullUpL;
        var downcount;
        var upcount;
        var loadingStep;//加载状态0默认，1显示加载状态，2执行加载数据，只有当为0时才能再次加载，这是防止过快拉动刷新
        var oldLen;
        var newLen;
        var len;
        var currentPageNum = 1;
        var url = '';
        /*以下为新加*/
        var lastPage = false; /*新加*/
        var scrollWrapperChild;
        var lastLineEL;

        _initCommonScroll();

        function _initCommonScroll(){
            downcount = 0;
            upcount = 0;
            loadingStep = 0;//加载状态0默认，1显示加载状态，2执行加载数据，只有当为0时才能再次加载，这是防止过快拉动刷新
            oldLen = 0 ;
            newLen = 4;
            //len =

            scrollWrapperChild = $(scrollWrapper).children();
            pullDownEl = $('<div id="pullDown"></div>');//下拉盒子
            pullDownEl.attr('class', 'ub ub-pc c-gra');
            pullDownEl.append($('<div class="pullDownIcon"></div>'));
            pullDownL = $('<div class="pullDownLabel">正在刷新...</div>');//pullDownEl.find('.pullDownLabel');
            pullDownEl.append(pullDownL);
            pullDownEl['class'] = pullDownEl.attr('class');
            pullDownEl.attr('class','').hide();
            scrollWrapperChild.prepend(pullDownEl);

            pullUpEl = $('<div id="pullUp"></div>');//上拉盒子
            pullUpEl.attr('class', 'ub ub-pc c-gra');
            pullUpEl.append('<div class="pullUpIcon"></div>');
            pullUpL = $('<div class="pullUpLabel">正在加载...</div>');//pullUpEl.find('.pullUpLabel');
            pullUpEl.append(pullUpL);
            pullUpEl['class'] = pullUpEl.attr('class');
            pullUpEl.attr('class','').hide();
        	scrollWrapperChild.append(pullUpEl);


        	lastLineEL = $('<div class="final">已经到最后一页了</div>');
            lastLineEL.hide();
            pullUpEl.before(lastLineEL);

            myScroll = new IScroll(scrollWrapper, {
                probeType: 2,//probeType：1对性能没有影响。在滚动事件被触发时，滚动轴是不是忙着做它的东西。probeType：2总执行滚动，除了势头，反弹过程中的事件。这类似于原生的onscroll事件。probeType：3发出的滚动事件与到的像素精度。注意，滚动被迫requestAnimationFrame（即：useTransition：假）。
                scrollbars: true,//有滚动条
                mouseWheel: true,//允许滑轮滚动
                fadeScrollbars: true,//滚动时显示滚动条，默认影藏，并且是淡出淡入效果
                bounce:true,//边界反弹
                interactiveScrollbars:true,//滚动条可以拖动
                shrinkScrollbars:'scale',// 当滚动边界之外的滚动条是由少量的收缩。'clip' or 'scale'.
                click: true ,// 允许点击事件
                keyBindings:true,//允许使用按键控制
                momentum:true// 允许有惯性滑动
            });

            //滚动时
            myScroll.on('scroll',function(){
                if(loadingStep == 0 && !pullDownEl.attr('class').match('flip|loading') && !pullUpEl.attr('class').match('flip|loading')){
                    if (this.y > 5) {
                        //下拉刷新效果
                        pullDownEl.attr('class',pullUpEl['class']);
                        pullDownEl.show();
                        myScroll.refresh();
                        pullDownEl.addClass('flip');
                       /*pullDownL.html('下拉准备刷新...');*/
                        loadingStep = 1;
                    }else if (this.y < (this.maxScrollY - 5) && !lastPage) {
                        //上拉刷新效果
                        pullUpEl.attr('class',pullUpEl['class'])
                        pullUpEl.show();
                        myScroll.refresh();
                        pullUpEl.addClass('flip');
                        /*pullUpL.html('上拉准备刷新...');*/
                        loadingStep = 1;
                    }
                }
            } );

            //滚动完毕
            myScroll.on('scrollEnd',function(){
                if(loadingStep == 1){
                    if (pullUpEl.attr('class').match('flip|loading')) {
                        pullUpEl.removeClass('flip').addClass('loading');
                        /*pullUpL.html('1正在刷新...');*/
                        loadingStep = 2;
                        _pullUpAction();
                        $("#_currentPageNum").val(currentPageNum);
                        myScroll.refresh();
                    }
                    else if(pullDownEl.attr('class').match('flip|loading')){
                        pullDownEl.removeClass('flip').addClass('loading');
                        /*pullDownL.html('2正在刷新...');*/
                        loadingStep = 2;
                        _pullDownAction();
                        $("#_currentPageNum").val(currentPageNum);
                        myScroll.refresh();
                    }
                }
            });
        }

        function _getURL(){
            var url = '';
            switch (itemTemplate){
                case 'trainingstyledetails' :
                    url = $.fn.getServerUrl()+"onlineTraining/onlinetrainingdataApp.do";
                    break;
                default:
                    url = '';
            }
            return url;
        }

        function getUrlParams(type){
        	//var d = '{';
        	var name='';
        	var d="";
        	currentPageNum = parseInt($("#_currentPageNum").val()+"")+1;
			var isnodata = $("#_isnodata").val();
            if(itemTemplate=='trainingstyledetails'){
               var types=$(".active").attr("value");
               d+= '?type='+types;
               d+= '&name='+name;
               d+= '&pageSize='+pageSize;
				if(type==1){//下拉，刷新
					currentPageNum = 1;
					d += '&pageIndex=1';
					//d+='"pageIndex":'+currentPageNum+",";
				}else{
					if(isnodata == '0'){
						currentPageNum = 1;
						d += '&pageIndex=1';
						//d+='"pageIndex":'+currentPageNum+",";
					}else{
						d += '&pageIndex='+currentPageNum;
						//d+='"pageIndex":'+currentPageNum+",";
					}

				}
            }
            //if(d.length>1){d=d.substring(0,d.length-1); }
          //  d+="}";
            return d;
        }

        function _pullDownAction() {//下拉事件
        //alert(1);
        	url = _getURL();
        	//alert(url);
        	var param = getUrlParams(1);
        	//alert("param:"+param);
            setTimeout(
                function () {
                	clearNoNewsNone();
                    $.ajax({
                        url: url+param ,
                        //data:param,
                        type: 'POST',
                        dataType: 'json',
                        success: _ajaxCallBackForPullDown
                    });

                    pullDownEl.removeClass('loading');
                   /*pullDownL.html('3下拉刷新...');*/
                    pullDownEl['class'] = pullDownEl.attr('class');
                    pullDownEl.attr('class','').hide();
                    myScroll.refresh();
                    loadingStep = 0;},
                1000); //1秒
        }

        function _pullUpAction() {//上拉事件
         	url = _getURL();
         	var param = getUrlParams(2);
            setTimeout(
                function() {
                	clearNoNewsNone();
                    $.ajax({
                        url: url+param,
                       // data:,
                        type: 'POST',
                        dataType: 'json',
                        success:_ajaxCallBackForPullUp
					});

                    pullUpEl.removeClass('loading');
                  /*pullUpL.html('4上拉显示更多...');*/
                    pullUpEl['class'] = pullUpEl.attr('class');
                    pullUpEl.attr('class','').hide();
                    myScroll.refresh();
                    loadingStep = 0},
                1000);
        }

		function getResultDate(data){
			var d = '';
            switch (itemTemplate){
                case 'trainingstyledetails' :
                    d = data.trainingclass;
                    //alert('d--这--'+d);
                    break;
//                  //培训班列表
//                case 'trainingclass' :
//                    d = data.tc_lists;
//                    break;
//                case 'courseCenter' :
//                    d = data.plists;
//                    break;
//                case 'myorder' :
//                    d = data.objList;
//                    break;
                default:
                    d = '';
            }
            return d;
		}
        function _ajaxCallBackForPullDown(data){
        //alert("_ajaxCallBackForPullDown");
        	lastLineEL.hide();
            var d = getResultDate(data);
            if(d!=''){
             	var addedItem ='';
            	$.each(d, function(k, itme){
            	//alert(k);
					addedItem += _createItemContent(itme);
				});
				//alert(addedItem);
				clearStyleBlock();
				listElement.html(addedItem);
            }else{
            	listElement.html('');
            	clearNoNewsBlock();
            }
            myScroll.refresh();/*新加*/
        }

        function _ajaxCallBackForPullUp(data){
        	if(currentPageNum > data.totalPage){/* !data -- 没有数据了，也就是到最后一页了*/
	            if(!lastPage) {
	                lastLineEL.show();
                    lastPage = true;
                    clearNoNewsBlock();
                    myScroll.refresh();
                    setTimeout(function(){
                            lastLineEL.hide();
                            lastPage = false;
                            myScroll.refresh();
                        },
                        1000);
	            }
	        }else{
        		lastPage = false;
	            var d = getResultDate(data);//d是后台返回的数据集合
	            //alert("d2:"+d)
				if(d!=''){
					var addedItem="";
					$.each(d, function(k, itme){
					//"k:"+k);
                    					addedItem += _createItemContent(itme);
                    				});
                    				//alert(addedItem);
	             	listElement.append(addedItem);
                	if(addedItem==''){
						clearNoNewsBlock();
					}else{
						clearStyleBlock();
					}
	            }
	        }
	        myScroll.refresh();
        }

		function clearStyleBlock(){
			if(currentPageNum==1){
	        	if(itemTemplate=='trainingstyledetails'){
					$("#_isnodata").val("1");
				}
        	}
		}

        function clearNoNewsNone(){
        	if(currentPageNum==1){
	        	if(itemTemplate=='trainingstyledetails'){
					$('#instant').hide();
					$('#add').css({'display':'block'});
				}
        	}
        }

        function clearNoNewsBlock(){
        	if(currentPageNum==1){
	        	if(itemTemplate=='trainingstyledetails'){
					$('#instant').show();
					$('#add').css({'display':'none'});
					$("#_isnodata").val("0");
				}
        	}
        }

        // type: 表示哪个网页，再根据网页需要，创建item的格式。
        function _createItemContent(data){
          var itemContent = '';
            switch (itemTemplate){
                case 'trainingstyledetails' :
                    itemContent = _createlessonLibraryListItem(data);
                    break;

            }
            return itemContent;
        }


	 	function _createlessonLibraryListItem (item){
        	          var str ="";
        	           if(item.tc_mode==724 ){
                        //alert('item.isfree----'+item.isfree);
                        if(item.hour != null && item.hour != ""){
                            hour= item.hour;
                        }else{
                            hour=0;
                        }
                    }
                    if(item.isfree!=null&&item.isfree<1){
                        isfree="免费";
                    }else{
                        isfree="";
                    }
                           str +='<div class="col-sm-12 col-xs-12">';
                           str +=' <input type="hidden" id="classtype" value="1">';
                           if(item.tc_mode==724){
                            str +='<a href="../../html/onlineClass/onlineClass-details.html?id='+item.id+'" class="auto child">';
                           }else if(item.tc_mode==725){
                            str +='<a href="../../html/facelesson/faceLesson-details.html?id='+item.id+'&type=0" class="auto child">';
                           }
                           str +='<div class="pic fr">';
                            /*if(item.img != "" && item.img !=null){
                                   str +='<img src="'+$.fn.getGKUrl()+"trainingclass/"+item.img+'" alt="" class="auto child">';
                               }else{
                                   str +='<img src="../../images/demoPic.jpg" alt="" class="auto child">';
                               }*/
                           str +='<img src="../../images/demoPic.jpg" alt="" class="auto child">';
                           str +='</div>';
                           str +='<div class="listTxt">';
                           if(item.tc_mode==724){
                            str +='<h5 class="ellipsis1"  style="margin-bottom: 16px;">'+item.tc_name+'</h5>';
                            str +='<p class="fz12 color9">培训时间：<span>'+item.begintime+'至 '+item.endtime+'</span></p>';
                            str +='<p class="fz12 color9" style="line-height: 22px;">培训学时：<span>'+hour+'学时</span></p>';
                            str +='</div>';
                            str +='<div class="class-tab fr">';
                            str +='<p class="colorWhite xianshang fr">线上培训班</p>';
                           }else if(item.tc_mode==725){
                            str +='<h5 class="ellipsis1"  style="margin-bottom: 16px;">'+item.tc_name+'</h5>';
                               str +='<p class="fz12 color9">报名时间：<span>'+item.signbegintime+' ~ '+item.signendtime+'</span></p>';
                               str +='<p class="fz12 color9" style="line-height: 22px;">培训地点：<span>'+item.place+'</span></p>';
                               str +='<p class="fz12 color9">培训日期：<span>'+item.begintime+'至 '+item.endtime+'</span></p>';
                               str +='</div>';
                               str +='<div class="class-tab fr">';
                               str +='<p class="colorWhite xianshang fr">面授培训班</p>';
                           }
                           str +='<p class="colorWhite mianfei fl">'+isfree+'</p>';
                           str +='</div></a></div>';
            return str;
        }
}
 function touchemoveFunction(e){e.preventDefault();}//禁用 touchmove
    document.addEventListener('touchmove', touchemoveFunction, false);
    document.addEventListener('DOMContentLoaded', loadScroller, false);
