var toastIndex = 0;
var toastCount = 0;
var $toastlast;
/*
success -- 成功
error   -- 败
warning -- 警告
info    -- 信息
*/
function showAlert(alert_message, shortCutFunction){
    var msg = alert_message;
    var title = '';
    toastIndex = toastCount++;
    window.top.toastr.options = {
    	"closeButton": true,
    	"debug": false,
    	"positionClass": "toast-top-right",
    	"onclick": null,
    	"showDuration": "1000",
    	"hideDuration": "1000",
    	"timeOut": "3000",
    	"extendedTimeOut": "1000",
    	"showEasing": "swing",
    	"hideEasing": "linear",
    	"showMethod": "fadeIn",
    	"hideMethod": "fadeOut"
    };

    if ($('#addBehaviorOnToastClick').prop('checked')) {
    	window.top.toastr.options.onclick = function () {
        	toastr.clear();
        };
    }
    var $toast = window.top.toastr[shortCutFunction](msg, title); // Wire up an event handler to a button in the toast, if it exists
    $toastlast = $toast;
    if ($toast.find('#okBtn').length) {
        $toast.delegate('#okBtn', 'click', function () {
        	//alert('you clicked me. i was toast #' + toastIndex + '. goodbye!');
        	$toast.remove();
        });
    }
    
    if ($toast.find('#surpriseBtn').length) {
        $toast.delegate('#surpriseBtn', 'click', function () {
        	//alert('Surprise! you clicked me. i was toast #' + toastIndex + '. You could perform an action here.');
        });
    }

    $('#clearlasttoast').click(function () {
        toastr.clear($toastlast);
    });
}

function hideLastAlert(){
	if($toastlast != undefined){
		$toastlast.remove();
	}
}

function showWarning(msg){
	if(msg == undefined || msg == ""){
		msg = "警告...";
	}	
	setTimeout(function(){
		hideLastAlert();
		showAlert(msg, "warning");
	},500)
}

function showInfo(msg){
	if(msg == undefined || msg == ""){
		msg = "正在修改...";
	}
	setTimeout(function(){
		hideLastAlert();
		showAlert(msg, "info");
	},500)
}

function showSuccess(msg){
	if(msg == undefined || msg == ""){
		msg = "保存成功";
	}	
	setTimeout(function(){
		hideLastAlert();
		showAlert(msg, "success");
	},500)
}

function showError(msg){
	if(msg == undefined || msg == ""){
		msg = "保存失败";
	}
	setTimeout(function(){
		hideLastAlert();
		showAlert(msg, "error");
	},500)
}

var btstart = function(obj){
	if(obj == undefined){
		obj=document.querySelector("#btload1");
	}
	var l = Ladda.create(obj);
	l.start();
}
    
var btstop = function(obj){
	if(obj == undefined){
		obj=document.querySelector("#btload1");
	}
	var l = Ladda.create(obj);
	setTimeout(function(){l.stop();}, 1000);
}