//用户信息
function user(){
	$.ajax({
		url : $.fn.getServerUrl()+"/myCenter/selectCenterUser.do",
		type : "POST",
		dataType: "json",
		async: false,
		success : function(response){
			var str="";
			var photo = "";
			var user = response.user;
			var groupName = response.groupName;
			var study = response.study;
			var finsh = response.finsh;
			if(user.photo!=null && user.photo!=""){
				     photo = '<img src="'+$.fn.getGKUrl()+'trainingclass/'+user.photo+'" alt="" class="behav"/>';
			}else{
             		 photo = '<img src="../../images/login_user.png" alt="" class="behav"/>';
             	  }
			str +='<div class="peoplePic behav text-center bgWhite boxCenter">';
			str +=photo;
			str +='</div>';
			str +='<div class="peopleText text-center">';
			str +='<h4 class="fweight">'+user.name+'</h4>';
			str +='<p class="color9">'+groupName+'</p>'
			str +='<a onclick="userSetup(\'' + user.id + '\')" class="setting"></a></p>';
			str +='<a href="../../html/mystudy/message.html?type=1" class="xx-message"></a>';
			str +='</div>';
			$("#userInfo").html(str);
		}
	})
}
user();
//学时数
function getStudyHour(){
	var sumhours=0;//总学时
	var currenthour=0.0;//当前循环监管学时
	var otherthour = 0.0;//循环其它学时
	var currentyearhour = 0.0;//本年度总学时
	var currentyear="";//
	var date=new Date;
	var year=date.getFullYear().toString();
	$.ajax({
		url:$.fn.getServerUrl()+'/myCenter/selectStudyRecord.do',
		type:'POST',
		dataType:'json',
		async: false,
		success : function(response){
			var list = response.list;
			if (list!=null) {
				$.each(list,function(k,item){
					sumhours+=item.chour;//总学时
					if (item.ctime!=null) {
						currentyear = getYear(item.ctime.time);
						if (currentyear == year) {
							currentyearhour+=item.chour;
							if (1==item.ctype) {
								currenthour+=item.chour;
							}else {
								otherthour+=item.chour;
							}
						}else {
							//htmlp = '您'+year+'年的学时任务共  <b class="num1 colorWhite">100</b>    学时   [  其中总学时差    <b class="num2 colorWhite">100</b>    学时，监管学时差   <b class="num3 colorWhite">10</b>     学时  ]';
						}
					}
				})
				$('#houryearnum').html(currentyearhour.toFixed(2));
				$('#hourtype').html(currenthour.toFixed(2));
				$('#hourother').html(otherthour.toFixed(2));
			}
		}
	});
}
getStudyHour();
//把后台传过来的时间转换为前台时间  年
function getYear(date){
	//将时间戳转为int类型，构造Date类型
	var date = new Date(parseInt(date,10));
	//月份得+1，且只有个位数时在前面+0
	var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
	var newTime = date.getFullYear();
	return newTime;
}

//最新课程
function showNewestLesson_index(){
	$.ajax({
    	url:$.fn.getServerUrl()+'/lesson/selectLesson_index.do',
		type:'POST',
		dataType:'json',
		async: false,
		success:function(result){
			if (result.lessonList != null) {
				var list = result.lessonList;
				var lessonDiv = "";
				var size=list.length;
				if(size > 2)  size=2;
				for (var i = 0; i < size; i++) {
					var lesson = list[i];
					var url = "../lesson/lessonDetails.html?lessonId="+lesson.id+"&returnType="+"zxnewLesson";
                    lessonDiv += '<div class="swiper-slide">';
                    lessonDiv += '<a href="'+url+'" class="pic child">';
                    if(lesson.img != null && lesson.img != ""){
                        lessonDiv += '<img src="'+$.fn.getGKUrl()+"lessonimg/"+lesson.img+'"  alt="" class="auto child"/>';
                    }else{
                        lessonDiv += '<img src="../images/demoPic.jpg" alt="" class="auto child"/>';
                    }
                    lessonDiv +='<h2 class="ellipsis1">'+lesson.le_name+'</h2>'
                    lessonDiv +='</div>';
				}
				$('#swiper-wrapper').html(lessonDiv);
			}
		}
	})
}
showNewestLesson_index();

function userSetup(id){
	window.location.href="../../html/usersetup/setting.html?id="+id;
}

function toDownLoad(){
    Cordova.exec(successFunction,failFunction, "DownloadAction", "action_download",[{}]);
}

function successFunction(){}
function failFunction(){
    //myDialog('加载失败！',['确认']);
}