/**
 * Created by xueyang on 2016/11/21.
 */

    var whichTemplate = $('meta[name=itemTemplate]').attr('content');
    function loadScroller(){
		setTimeout(
        	function(){
        		commonScroll('#content','#add', whichTemplate);
        	},
        150);
    }
    function commonScroll(el,listID,itemTemplate){
        var scrollWrapper = el;
        var listElement = $(listID);
        var myScroll;
        var pullDownEl;
        var pullDownL;
        var pullUpEl;
        var pullUpL;
        var downcount;
        var upcount;
        var loadingStep;//加载状态0默认，1显示加载状态，2执行加载数据，只有当为0时才能再次加载，这是防止过快拉动刷新
        var oldLen;
        var newLen;
        var len;
        var currentPageNum = 1;
        var url = '';
        /*以下为新加*/
        var lastPage = false; /*新加*/
        var scrollWrapperChild;
        var lastLineEL;

        _initCommonScroll();

        function _initCommonScroll(){
            downcount = 0;
            upcount = 0;
            loadingStep = 0;//加载状态0默认，1显示加载状态，2执行加载数据，只有当为0时才能再次加载，这是防止过快拉动刷新
            oldLen = 0 ;
            newLen = 4;
            //len =

            scrollWrapperChild = $(scrollWrapper).children();
            pullDownEl = $('<div id="pullDown"></div>');//下拉盒子
            pullDownEl.attr('class', 'ub ub-pc c-gra');
            pullDownEl.append($('<div class="pullDownIcon"></div>'));
            pullDownL = $('<div class="pullDownLabel">正在刷新...</div>');//pullDownEl.find('.pullDownLabel');
            pullDownEl.append(pullDownL);
            pullDownEl['class'] = pullDownEl.attr('class');
            pullDownEl.attr('class','').hide();
            scrollWrapperChild.prepend(pullDownEl);

            pullUpEl = $('<div id="pullUp"></div>');//上拉盒子
            pullUpEl.attr('class', 'ub ub-pc c-gra');
            pullUpEl.append('<div class="pullUpIcon"></div>');
            pullUpL = $('<div class="pullUpLabel">正在加载...</div>');//pullUpEl.find('.pullUpLabel');
            pullUpEl.append(pullUpL);
            pullUpEl['class'] = pullUpEl.attr('class');
            pullUpEl.attr('class','').hide();
            if(itemTemplate=='studyCard'){
                scrollWrapperChild.after(pullUpEl);
            }else{
                scrollWrapperChild.append(pullUpEl);
            }



        	lastLineEL = $('<div class="final">已经到最后一页了</div>');
            lastLineEL.hide();
            pullUpEl.before(lastLineEL);

            myScroll = new IScroll(scrollWrapper, {
                probeType: 2,//probeType：1对性能没有影响。在滚动事件被触发时，滚动轴是不是忙着做它的东西。probeType：2总执行滚动，除了势头，反弹过程中的事件。这类似于原生的onscroll事件。probeType：3发出的滚动事件与到的像素精度。注意，滚动被迫requestAnimationFrame（即：useTransition：假）。
                scrollbars: true,//有滚动条
                mouseWheel: true,//允许滑轮滚动
                fadeScrollbars: true,//滚动时显示滚动条，默认影藏，并且是淡出淡入效果
                bounce:true,//边界反弹
                interactiveScrollbars:true,//滚动条可以拖动
                shrinkScrollbars:'scale',// 当滚动边界之外的滚动条是由少量的收缩。'clip' or 'scale'.
                click: true ,// 允许点击事件
                keyBindings:true,//允许使用按键控制
                momentum:true// 允许有惯性滑动
            });

            //滚动时
            myScroll.on('scroll',function(){
                if(loadingStep == 0 && !pullDownEl.attr('class').match('flip|loading') && !pullUpEl.attr('class').match('flip|loading')){
                    if (this.y > 5) {
                        //下拉刷新效果
                        pullDownEl.attr('class',pullUpEl['class']);
                        pullDownEl.show();
                        myScroll.refresh();
                        pullDownEl.addClass('flip');
                       /*pullDownL.html('下拉准备刷新...');*/
                        loadingStep = 1;
                    }else if (this.y < (this.maxScrollY - 5) && !lastPage) {
                        //上拉刷新效果
                        pullUpEl.attr('class',pullUpEl['class'])
                        pullUpEl.show();
                        myScroll.refresh();
                        pullUpEl.addClass('flip');
                        /*pullUpL.html('上拉准备刷新...');*/
                        loadingStep = 1;
                    }
                }
            } );

            //滚动完毕
            myScroll.on('scrollEnd',function(){
                if(loadingStep == 1){
                    if (pullUpEl.attr('class').match('flip|loading')) {
                        pullUpEl.removeClass('flip').addClass('loading');
                        /*pullUpL.html('1正在刷新...');*/
                        loadingStep = 2;
                        _pullUpAction();
                        $("#_currentPageNum").val(currentPageNum);
                        myScroll.refresh();
                    }
                    else if(pullDownEl.attr('class').match('flip|loading')){
                        pullDownEl.removeClass('flip').addClass('loading');
                        /*pullDownL.html('2正在刷新...');*/
                        loadingStep = 2;
                        _pullDownAction();
                        $("#_currentPageNum").val(currentPageNum);
                        myScroll.refresh();
                    }
                }
            });
        }

        function _getURL(){
            var url = '';
            switch (itemTemplate){
                case 'lessonLibrary' ://课程库
                    url = $.fn.getServerUrl()+"lesson/selectLessonApp.do";
                    break;
                case 'studyCard' ://学时购买记录
                	url = $.fn.getServerUrl()+"/studyCard/buyRecord.do";
                	break;
                case 'myLesson' ://我的课程
                    url = $.fn.getServerUrl()+"/lesson/getLessonByConditionToApp.do";
                    break;
                case 'myTraining' ://我的培训班
                    url = $.fn.getServerUrl()+"/myTrainingClass/getMyTrainingClassByConditionToApp.do";
                    break;
                case 'file'://学习档案
                    url =  $.fn.getServerUrl()+"/myCenter/selectArchivesStudytimeApp.do";
                    break;
                case 'mySurvey' ://我的调查
                    url = $.fn.getServerUrl()+"/faceTraining/getMySurveyByConditionToApp.do";
                    break;
                case 'myCollection'://收藏
                    url = $.fn.getServerUrl()+"/collect/getLessonConllectionListApp.do";
                    break;
                case 'faceMember'://学员名单
                	url = $.fn.getServerUrl()+"faceTraining/getTrainingUser.do";
                	break;
                case 'faceEvaluate'://评论
                	url = $.fn.getServerUrl()+"onlineTraining/getTrainingEvaluateApp.do";
                	break;
                default:
                    url = '';
            }
            return url;
        }

        function getUrlParams(type){
        	//var d = '{';
        	var d="";
        	currentPageNum = parseInt($("#_currentPageNum").val()+"")+1;
			var isnodata = $("#_isnodata").val();
            if(itemTemplate=='lessonLibrary'){
               d+= '?level='+level;
              // d+='"level":'+level+",";
               d+= '&id='+id;
               d+= '&lessonType='+lessonType;
               d+= '&sort='+lessoncon;
               //d+='"id":'+id+",";
               d+= '&pageSize='+pageSize;
               //d+='"pageSize":'+pageSize+",";
                //var type1 = $("#_type").val();
                //d = '?type='+type1;
                //d+='"type":'+type1+",";
                if(type==1){//下拉，刷新
                    currentPageNum = 1;
                    d += '&pageIndex=1';
                    //d+='"pageIndex":'+currentPageNum+",";
                }else{
                    if(isnodata == '0'){
                        currentPageNum = 1;
                        d += '&pageIndex=1';
                        //d+='"pageIndex":'+currentPageNum+",";
                    }else{
                        d += '&pageIndex='+currentPageNum;
                        //d+='"pageIndex":'+currentPageNum+",";
                    }
                }
            }
            //学时卡购买记录
            if(itemTemplate=='studyCard'){
            	d+='?pageSize='+pageSize;
            	if(type==1){//下拉，刷新
					currentPageNum = 1;
					d += '&pageIndex=1';
				}else{
					if(isnodata == '0'){
						currentPageNum = 1;
						d += '&pageIndex=1';
					}else{
						d += '&pageIndex='+currentPageNum;
					}
				}
            }
            //我的课程
            if(itemTemplate=='myLesson'){
                var lessonType=$(".active").attr("data_type");
                var isFinish=$(".on").attr("data_isfinish");
                d+='?lessonType='+lessonType;
                d+='&isFinish='+isFinish;
                d+='&pageSize='+pageSize;
                if(type==1){//下拉，刷新
                    currentPageNum = 1;
                    d += '&pageIndex=1';
                }else{
                    if(isnodata == '0'){
                        currentPageNum = 1;
                        d += '&pageIndex=1';
                    }else{
                        d += '&pageIndex='+currentPageNum;
                    }
                }
            }
            //我的培训班
            if(itemTemplate=='myTraining'){
                var classType=$(".active").attr("data_classType");//获取培训班类型
                var isEnd=$(".on").attr("data_isEnd");//获取培训班是否结束；
                d+='?classType='+classType;
                d+='&isEnd='+isEnd;
                d+='&pageSize='+pageSize;
                if(type==1){//下拉，刷新
                    currentPageNum = 1;
                    d += '&pageIndex=1';
                }else{
                    if(isnodata == '0'){
                        currentPageNum = 1;
                        d += '&pageIndex=1';
                    }else{
                        d += '&pageIndex='+currentPageNum;
                    }
                }
            }

            //我的培训班
            if(itemTemplate=='file'){
                var studyType = $('.on').attr('value');//获取类型
                //alert("studyType:"+studyType);
                d+='?studyType='+studyType;
                d+='&pageSize='+pageSize;
                if(type==1){//下拉，刷新
                    currentPageNum = 1;
                    d += '&pageIndex=1';
                }else{
                    if(isnodata == '0'){
                        currentPageNum = 1;
                        d += '&pageIndex=1';
                    }else{
                        d += '&pageIndex='+currentPageNum;
                    }
                }
            }
            //我的调查
            if(itemTemplate=='mySurvey'){
                var surveyType=$(".current").attr("data_surveType");
                d+='?surveyType='+surveyType;
                d+='&pageSize='+pageSize;
                if(type==1){//下拉，刷新
                    currentPageNum = 1;
                    d += '&pageIndex=1';
                }else{
                    if(isnodata == '0'){
                        currentPageNum = 1;
                        d += '&pageIndex=1';
                    }else{
                        d += '&pageIndex='+currentPageNum;
                    }
                }
            }
            //我的收藏
            if(itemTemplate=='myCollection'){
                var collectionType=$(".current").attr("value");
                d+='?collectionType='+collectionType;
                d+='&pageSize='+pageSize;
                if(type==1){//下拉，刷新
                    currentPageNum = 1;
                    d += '&pageIndex=1';
                }else{
                    if(isnodata == '0'){
                        currentPageNum = 1;
                        d += '&pageIndex=1';
                    }else{
                        d += '&pageIndex='+currentPageNum;
                    }
                }
            }
            //学员名单
            if(itemTemplate=='faceMember'){
            	d+='?id='+id;
            	d+='&pageSize='+pageSize;
            	if(type==1){//下拉，刷新
            		currentPageNum = 1;
            		d += '&pageIndex=1';
            	}else{
            		if(isnodata == '0'){
            			currentPageNum = 1;
            			d += '&pageIndex=1';
            		}else{
            			d += '&pageIndex='+currentPageNum;
            		}
            	}
            }
            //评论
            if(itemTemplate=='faceEvaluate'){
            	d+='?id='+id;
            	d+='&pageSize='+pageSize;
            	if(type==1){//下拉，刷新
            		currentPageNum = 1;
            		d += '&pageIndex=1';
            	}else{
            		if(isnodata == '0'){
            			currentPageNum = 1;
            			d += '&pageIndex=1';
            		}else{
            			d += '&pageIndex='+currentPageNum;
            		}
            	}
            }
            //if(d.length>1){d=d.substring(0,d.length-1); }
          //  d+="}";
           // alert("d1---:"+d);
            return d;
        }

        function _pullDownAction() {//下拉事件
        //alert(1);
        	url = _getURL();
        	//alert(url);
        	var param = getUrlParams(1);
        //	alert(param);
            setTimeout(
                function () {
                	clearNoNewsNone();
                    $.ajax({
                        url: url+param ,
                       // data:param,
                        type: 'POST',
                        dataType: 'json',
                        success: _ajaxCallBackForPullDown
                    });

                    pullDownEl.removeClass('loading');
                   /*pullDownL.html('3下拉刷新...');*/
                    pullDownEl['class'] = pullDownEl.attr('class');
                    pullDownEl.attr('class','').hide();
                    myScroll.refresh();
                    loadingStep = 0;},
                1000); //1秒
        }

        function _pullUpAction() {//上拉事件
         	url = _getURL();
         	var param = getUrlParams(2);
         	//alert('param:'+param);
            setTimeout(
                function() {
                	clearNoNewsNone();
                    $.ajax({
                        url: url+param,
                        //data:param,
                        type: 'POST',
                        dataType: 'json',
                        success:_ajaxCallBackForPullUp
					});

                    pullUpEl.removeClass('loading');
                  /*pullUpL.html('4上拉显示更多...');*/
                    pullUpEl['class'] = pullUpEl.attr('class');
                    pullUpEl.attr('class','').hide();
                    myScroll.refresh();
                    loadingStep = 0},
                1000);
        }

		function getResultDate(data){
			var d = '';
            switch (itemTemplate){
                case 'lessonLibrary' :
                    d = data.lessonList;
                    break;
                //学时卡购买记录
                case 'studyCard' :
                	d = data.orderList;
                	break;
                //我的课程
                case 'myLesson' :
                    d = data.myLessonList;
                    break;
                //我的培训班
                case 'myTraining' :
                    d = data.myTrainingClassList;
                    break;
                //学时档案
                case 'file' :
                    d = data.ArchivesStudytime;
                    break;
                //我的调查
                case 'mySurvey' :
                    d = data.mySurveyList;
                    break;
                //收藏
                case 'myCollection':
                    d = data.lessonCollectionList;
                    break;
                //学员名单
                case 'faceMember':
                	d = data.users;
                	break;
                case 'faceEvaluate':
                	d = data.evaluate;
                	break;
//                  //培训班列表
//                case 'trainingclass' :
//                    d = data.tc_lists;
//                    break;
//                case 'courseCenter' :
//                    d = data.plists;
//                    break;
//                case 'myorder' :
//                    d = data.objList;
//                    break;
                default:
                    d = '';
            }
            return d;
		}
        function _ajaxCallBackForPullDown(data){
        //alert("_ajaxCallBackForPullDown");
        	lastLineEL.hide();
            var d = getResultDate(data);
            if(d!=''){
             	var addedItem ='';
            	$.each(d, function(k, itme){
            	//alert(k);
					addedItem += _createItemContent(itme);
				});
				//alert(addedItem);
				clearStyleBlock();
				listElement.html(addedItem);
            }else{
            	listElement.html('');
            	clearNoNewsBlock();
            }
            myScroll.refresh();/*新加*/
        }

        function _ajaxCallBackForPullUp(data){
        	if(currentPageNum > data.totalPage){/* !data -- 没有数据了，也就是到最后一页了*/
	            if(!lastPage) {
	                lastLineEL.show();
                    lastPage = true;
                    clearNoNewsBlock();
                    myScroll.refresh();
                    setTimeout(function(){
                            lastLineEL.hide();
                            lastPage = false;
                            myScroll.refresh();
                        },
                        1000);
	            }
	        }else{
        		lastPage = false;
	            var d = getResultDate(data);//d是后台返回的数据集合
				if(d!=''){
					var addedItem="";
					$.each(d, function(k, itme){
                    					addedItem += _createItemContent(itme);
                    				});
	             	//listElement.append(addedItem);
	             	//alert('add----append之前:'+$('#add').html());
	             	//alert("addedItem:"+addedItem);
	             	listElement.append(addedItem);
	             	//alert('add---append之后:'+$('#add').html());
                	if(addedItem==''){
						clearNoNewsBlock();
					}else{
						clearStyleBlock();
					}
	            }
	        }
	        myScroll.refresh();
        }

		function clearStyleBlock(){
			if(currentPageNum==1){
	        	if(itemTemplate=='lessonLibrary'){
					$("#_isnodata").val("1");
				}
	        	//学时卡购买记录
	        	if(itemTemplate=='studyCard'){
	        		$("#_isnodata").val("1");
	        	}
	        	//我的课程
                if(itemTemplate=='myLesson'){
                    $("#_isnodata").val("1");
                }
                //我的培训班
                if(itemTemplate=='myTraining'){
                    $("#_isnodata").val("1");
                }
                 //学时档案
                if(itemTemplate=='file'){
                    $("#_isnodata").val("1");
                }
                //我的调查
                if(itemTemplate=='mySurvey'){
                    $("#_isnodata").val("1");
                }
                //我的收藏
                if(itemTemplate=='myCollection'){
                     $("#_isnodata").val("1");
                }
                //学员名单
                if(itemTemplate=='faceMember'){
                	$("#_isnodata").val("1");
                }
                //评论
                if(itemTemplate=='faceEvaluate'){
                	$("#_isnodata").val("1");
                }
        	}
		}

        function clearNoNewsNone(){
        	if(currentPageNum==1){
	        	if(itemTemplate=='lessonLibrary'){
					$('#instant').hide();
					$('#add').css({'display':'block'});
				}
	        	//学时卡购买记录
	        	if(itemTemplate=='studyCard'){
					$('#instant').hide();
					$('#add').css({'display':'block'});
				}
				//我的课程
                if(itemTemplate=='myLesson'){
                    $('#instant').hide();
                    $('#add').css({'display':'block'});
                }
                //我的培训班
                if(itemTemplate=='myTraining'){
                    $('#instant').hide();
                    $('#add').css({'display':'block'});
                }
                //学时档案
                if(itemTemplate=='file'){
                    $('#instant').hide();
                    $('#add').css({'display':'block'});
                }
                //我的调查
                if(itemTemplate=='mySurvey'){
                    $('#instant').hide();
                    $('#add').css({'display':'block'});
                }
                //我的收藏
                if(itemTemplate=='myCollection'){
                    $('#instant').hide();
                    $('#add').css({'display':'block'});
                }
                //学员名单
                if(itemTemplate=='faceMember'){
                	$('#instant').hide();
                	$('#add').css({'display':'block'});
                }
                //评论
                if(itemTemplate=='faceEvaluate'){
                	$('#instant').hide();
                	$('#add').css({'display':'block'});
                }
        	}
        }

        function clearNoNewsBlock(){
        	if(currentPageNum==1){
	        	if(itemTemplate=='lessonLibrary'){
					$('#instant').show();
					$('#add').css({'display':'none'});
					$("#_isnodata").val("0");
				}
	        	//学时卡购买记录
	        	if(itemTemplate=='studyCard'){
					$('#instant').show();
					$('#add').css({'display':'none'});
					$("#_isnodata").val("0");
				}
				//我的课程
                if(itemTemplate=='myLesson'){
                    $('#instant').show();
                    $('#add').css({'display':'none'});
                    $("#_isnodata").val("0");
                }
                //我的培训班
                if(itemTemplate=='myTraining'){
                    $('#instant').show();
                    $('#add').css({'display':'none'});
                    $("#_isnodata").val("0");
                }
                 //学时档案
                if(itemTemplate=='file'){
                    $('#instant').show();
                    $('#add').css({'display':'none'});
                    $("#_isnodata").val("0");
                }
                //我的调查
                if(itemTemplate=='mySurvey'){
                    $('#instant').show();
                    $('#add').css({'display':'none'});
                    $("#_isnodata").val("0");
                }
                //我的收藏
                if(itemTemplate=='myCollection'){
                    $('#instant').show();
                    $('#add').css({'display':'none'});
                    $("#_isnodata").val("0");
                }
                //学员名单
                if(itemTemplate=='faceMember'){
                	$('#instant').show();
                	$('#add').css({'display':'none'});
                	$("#_isnodata").val("0");
                }
                //评论
                if(itemTemplate=='faceEvaluate'){
                	$('#instant').show();
                	$('#add').css({'display':'none'});
                	$("#_isnodata").val("0");
                }
        	}
        }

        // type: 表示哪个网页，再根据网页需要，创建item的格式。
        function _createItemContent(data){
          var itemContent = '';
            switch (itemTemplate){
                case 'lessonLibrary' :
                    itemContent = _createlessonLibraryListItem(data);
                    break;
                //学时卡购买记录
                case 'studyCard' :
                	itemContent = _createStudyCardListItem(data);
                    break;
                //我的课程
                case 'myLesson' :
                    itemContent = _createMyLessonListItem(data);
                    break;
                //我的培训班
                case 'myTraining' :
                    itemContent = _createMyTrainingClassListItem(data);
                    break;
                //学时档案
                case 'file':
                    itemContent = _createMystudyfile(data);
                    break;
                //我的调查
                case 'mySurvey' :
                    itemContent = _createMySurveyListItem(data);
                    break;
                //我的收藏
                case 'myCollection' :
                    itemContent = _createCollection(data);
                    break;
                    //学员名单
                case 'faceMember' :
                	itemContent = _createfaceMember(data);
                	break;
                	//评论
                case 'faceEvaluate' :
                	itemContent = _createfaceEvaluate(data);
                	break;
            }
            return itemContent;
        }

        //我的调查
        function _createMySurveyListItem(items){
        	var surveyType=$(".current").attr("data_surveType");
            var $div="";
            var beginTimeType="";
            var objectType="";
            var finishStatus="";
            if(items.finishStatus =='已交卷'){
                finishStatus='<div class="statetype hasjiaojuan"></div>';
            }else if(items.finishStatus == '未开始'){
                finishStatus='<div class="statetype hasend"></div>';
            }else if(items.finishStatus == '已结束'){
                finishStatus='<div class="statetype hasend"></div>';
            }else if(items.finishStatus == '未交卷'){
                finishStatus='<div class="statetype hasing"></div>';
            }
            if(surveyType == 1 || surveyType =='1'){
                beginTimeType='<p class="intro fz12 color9 ellipsis1">调查时间：<span>'+items.tcbegintime+' ~ '+items.tcendtime+'</span></p>'
                objectType='<p class="intro fz12 color9 ellipsis1">调查对象：<span>'+items.tc_name+'</span></p>'
            }else if(surveyType == 0 || surveyType == '0'){
                beginTimeType='<p class="intro fz12 color9 ellipsis1">评估时间：<span>'+items.tcbegintime+' ~ '+items.tcendtime+'</span></p>'
                objectType='<p class="intro fz12 color9 ellipsis1">评估对象：<span>'+items.tc_name+'</span></p>'
            }
            $div += '<div class="col-sm-12 col-xs-12  bgWhite p15">'+
                        '<a href="javascript:;" class="auto child">'+
                            '<div class="listTxt">'+
                                '<h5 class="ellipsis1">'+items.demand_name+'</h5>'+
                                beginTimeType+
                                objectType+
                            '</div>'+
                        '</a>'+
                        finishStatus+
                    '</div>';
            return $div;
        }

        //我的培训班
        function _createMyTrainingClassListItem(items){
           var isEnd=$(".on").attr("data_isEnd");//获取培训班是否结束；
           var $div="";
           var id = items.tcid;
           var url="..html/trainingClass/trainingClassDetails.html?tc_id="+id;
           var trainingImg="";
           var trainingType="";
           var isFree="";
           var progress="";
           var isends="";
           var userStudy="";
           var signbegintime="";
           var signendtime="";
           if(items.tcimg != ""){
               trainingImg='<img src="'+$.fn.getGKUrl()+"training/"+items.tcimg+'" alt="" class="auto child">';
           }else{
               trainingImg='<img src="../../images/demoPic.jpg" alt="" class="auto child">';
           }
           if(isEnd == -1 || isEnd == '-1'){
               isends='<span class="colorBlue">[&nbsp;进行中&nbsp;]</span>';
           }else if (isEnd == 1 || isEnd == '1'){
               isends='<span class="colorRed">[&nbsp;已结束&nbsp;]</span>';
           }
           if(items.tcmode=='724' || items.tcmode==724){
               signbegintime=items.toebegintime;
               signendtime=items.toeendtime;
               trainingType='<p class="colorWhite xianshang fr">线上培训班</p>';
               progress+='<div class="progress" style="">'+
                            '<div class="progress-bar progress-bar-success progress-bar-striped" role="progressbar" aria-valuenow="'+items.studyplan+'" aria-valuemin="0" aria-valuemax="100" style="width: '+items.studyplan+'%">'+
                            '</div>'+
                         '</div>';

               userStudy='<p class="fz12 color9 ellipsis1">培训进度：<span>40%</span>&nbsp;'+isends+'</p>'
           }else if(items.tcmode=='725' || items.tcmode==725){
               signbegintime=items.signbegintime
               signendtime=items.signendtime
               trainingType='<p class="colorWhite mianshou fr">面授培训班</p>';
               userStudy='<p class="fz12 color9  ellipsis1">培训地点：<span>'+items.tcplace+'</span>&nbsp;'+isends+'</p>';
           }
           if(items.tcisfree == 0 || items.tcisfree =='0'){
               isFree='<p class="colorWhite mianfei fl">免费</p>'
           }
           $div += '<div class="col-sm-12 col-xs-12">'+
                        '<a href="'+url+'" class="auto child">'+
                            '<div class="pic fr">'+
                                trainingImg+
                            '</div>'+
                            '<div class="listTxt">'+
                                '<h5 class="ellipsis1"  style="margin-bottom: 16px;">'+items.tcname+'</h5>'+
                                '<p class="fz12 color9 ellipsis1">报名时间：<span>'+signbegintime+' ~ '+signendtime+'</span></p>'+
                                '<p class="fz12 color9 ellipsis1">培训日期：<span>'+items.tcbegintime+' ~ '+items.tcendtime+'</span></p>'+
                                userStudy+
                            '</div>'+
                            '<div class="class-tab fr">'+
                                trainingType+
                                isFree+
                            '</div>'+
                            progress+
                        '</a>'+
                    '</div>';
           return $div;
        }

        //我的课程
        function _createMyLessonListItem(items){
            var $div="";
            var keywords = items.keyword.split(',');
            var keywordss="";
            if(keywords != null){
                for (var i=0;i<keywords.length;i++){
                    if("" != keywords[i]){
                        keywordss += '<span class="fz14">'+keywords[i]+'</span>';
                    }
                }
            }
            var id = items.id;
            var lessonType = "";
            var isfree = "";
            var url="../html/lesson/lessonDetails.html?lessonId="+id;
            var lessonImg="";
            if(items.isfree ==0){
                isfree='<p class=" colorWhite mianfei">免费</p>';
            }
            if(items.lesson_type==0){
                lessonType='<p class=" colorWhite bixiu">必修课</p>';
            }else if(items.lesson_type==1){
                lessonType='<p class=" colorWhite xuanxiu">选修课</p>';
            }
            if(items.img != ""){
                lessonImg='<img src="'+$.fn.getGKUrl()+"lessonimg/"+items.img+'" alt="" class="auto child">';
            }else{
                lessonImg='<img src="../../images/demoPic.jpg" alt="" class="auto child">';
            }
            $div+='<div class="col-sm-12 col-xs-12">'+
                        '<a href="'+url+'" class="auto child">'+
                            '<div class="pic fl">'+
                                lessonImg+
                            '</div>'+
                            '<div class="listTxt">'+
                                '<h5 class="ellipsis2">'+items.le_name+'</h5>'+
                                '<div class="row-bottom auto">'+
                                    '<p class="fz12 color9 fl"> '+items.teacher+'</p>'+
                                    '<p class="fz12 color9 fr">学时：<span>'+items.hour+'学时</span></p>'+
                                '</div>'+
                            '</div>'+
                            '<div class="progress" style="">'+
                                '<div class="progress-bar progress-bar-success progress-bar-striped" role="progressbar" aria-valuenow="'+items.studyplan+'" aria-valuemin="0" aria-valuemax="100" style="width: '+items.studyplan+'%">'+
                                '</div>'+
                            '</div>'+
                           '<div class="class-tab">'+
                                lessonType+
                                isfree+
                            '</div>'+
                        '</a>'+
                        '<div class="p15 m-15 clearfix">'+
                            '<p class="color9 fz12 fl">学习进度：<span>'+items.studyplan+'%</span></p>'+
                            '<div class="lesson-btn-row fr">'+
                            keywordss+
                            '</div>'+
                        '</div>'+
                    '</div>';
           //alert($div);
            return $div;
        }
        //学时卡购买记录
        function _createStudyCardListItem(itmes){
        	var orderTable = "";
			var card = "";// 学时卡类型
			var payMethod="";//支付方式
			//$.each(itme, function(k, itmes){
                if(itmes.card_type == 0){
                    card = "年卡";
                }else if(itmes.card_type == 1){
                    card = ""+parseInt(itmes.hour)+"学时卡";
                }
                if(itmes.order_pay_method ==0){
                    payMethod ="公付购买";
                }else if(itmes.order_pay_method==1){
                    payMethod ="个人购买";
                }
                orderTable += '<li>'+
                                   '<a href="javascirpt:;">'+
                                       card+'（'+payMethod+'）'+
                                   '</a>'+
                               '</li>';
           // })
            // alert(orderTable);
			return orderTable;
        }

	 	function _createlessonLibraryListItem (itme){
	 	//alert("_createlessonLibraryListItem---"+itme.id);
        	          var $div ="";
     	    			var keywords={};
     	    			if(itme.keyword!=null){
     	    				 keywords = itme.keyword.split(',');
     	    			}
     	    			var id = itme.id;
     	    			var lessonType = itme.lesson_type;
     	    			var isfree = itme.isfree;
     	    			var url="";
     	    			var progress = itme.studyplan;// 学习进度
     					if(progress == null || progress == ""){
     						progress = 0;
     					}
     					var browseamount=itme.browseamount==null?0:itme.browseamount;//浏览量
     					var collectionamount=itme.collectionamount==null?0:itme.collectionamount;//收藏量
     					var praiseamount=itme.praiseamount==null?0:itme.praiseamount;//点赞量
     					var evalCount=itme.evalCount==null?0:itme.evalCount;//评论总数
     					var url = "../lesson/lessonDetailsStudeyed.html?lessonId="+id;
                         $div +=	'<div class="col-sm-12 col-xs-12">';
                         $div +=	'    <a href="'+url+'"  class="auto child">';
                         $div +=	'        <div class="pic fl">';
                         $div +=	'     <img src="'+$.fn.getGKUrl()+"lessonimg/"+itme.img+'" alt="" class="auto child"/>';
                         $div +=	'       </div>';
                         $div +=	'       <div class="listTxt">';
                         $div +=	' <h5 class="ellipsis2">'+itme.le_name+'</h5>';
                         $div +=	'   <div class="row-bottom">';
                         $div +=	'    <p class="fz12 color9">学时：<span>'+itme.hour+'学时</span></p>';
                         $div +=	'    </div>';
                         $div +=	'   </div>';
                         $div +=	'        <div class="class-tab">';
                         // 0 必修 1 选修
                        if(lessonType == 0)  $div +=' <p class=" colorWhite bixiu">必修课</p>';
                        if(lessonType == 1)  $div +=' <p class=" colorWhite xuanxiu">选修课</p>';
                        // 是否免费 0：是 1：否
                         if(isfree == 0) $div +=' <p class=" colorWhite mianfei">免费</p>';
                         $div +='	        </div>';
                         $div +='	    </a>';
                         $div +='	    <div class="clearfix classIco">';
                         $div +='       <p class="col-sm-3 col-xs-3">';
                         $div +='	            <img src="../../images/classIco1.png" alt="">';
                         $div +=	'            <span class="">收藏 (<b>'+collectionamount+'</b>)</span>';
                         $div +='        </p>';
                         $div +='        <p class=" col-sm-3 col-xs-3">';
                         $div +='	            <img src="../../images/classIco2.png" alt="">';
                         $div +='            <span class="">点赞 (<b>'+praiseamount+'</b>)</span>';
                         $div +='	         </p>';
                         $div +='	        <p class=" col-sm-3 col-xs-3">';
                         $div +='	            <img src="../../images/classIco3.png" alt="">';
                         $div +='            <span class="">评论 (<b>'+evalCount+'</b>)</span>';
                         $div +='        </p>';
                         $div +='	        <p class=" col-sm-3 col-xs-3 text-right">';
                         $div +='            <img src="../images/classIco4.png" alt="">';
                         $div +='            <span class="">点击量 (<b>'+browseamount+'</b>)</span>';
                         $div +='        </p>';
                         $div +='    </div>';
                         $div +='	 </div>';
                         //alert($div);
            return $div;
        }
            //学时档案
            function _createMystudyfile(item){
            //alert("getfrom_source(item.from_source):"+getfrom_source(item.from_source));
                var str = "";
                str+='<li class="">';
                str+='<p class="color9 fr">'+getfrom_source(item.from_source)+' </p>';
                str+='<h6 class="" >'+item.title+'</h6>';
                str+='</li>';
                //alert('str:'+str);
                return str;
            }
            //收藏
            function _createCollection(item){
                var str = "";
    			var collectionamount = 0;
    			var praiseamount = 0;
    			var evalcount = 0;
    			var browseamount = 0;
    			var lesson_type = "";
    			var isfree = "";
    			var studyplan = 0;
    			var progressing = "";
    			var newtime = new Date().getTime();
                if('class'==item.type){
                	var classCost = '';
					var classType = '';
					if(item.isfree==null || item.isfree){
						classCost = '';
					}else if(item.isfree==0){
						classCost = '免费';
					}
					if(item.tc_mode==724){
						classType = '线上培训班';
					}
					if(item.tc_mode==725){
						classType = '面授培训班';
					}
					if("undefined" != typeof(item.studyplan)&& item.studyplan != "" && item.studyplan != null) {
						studyplan = item.studyplan;
					}
					if(newtime< new Date(item.begintime).getTime()) {
						progressing = "未开始";
					}
					if(newtime> new Date(item.endtime).getTime()) {
						progressing = "已结束";
					}
					if(new Date(item.begintime).getTime()<newtime< new Date(item.endtime).getTime()) {
						progressing = "进行中";
					}
                	str += '<div class="col-sm-12 col-xs-12 forSelect">';
                	str += '<a href="javascript:;" class="auto child">';
                	str += ' <div class="pic fr">';
                	str += '<img src="../../images/demoPic.jpg" alt="" class="auto child">';
                	str += '</div>';
                	str += '<div class="listTxt">';
                	str += '<h5 class="ellipsis1"  style="margin-bottom: 16px;">'+item.tc_name+'</h5>';
                	str += '<p class="fz12 color9 ellipsis1">报名时间：<span>'+item.signbegintime+' ~ '+item.signendtime+'</span></p>';
                	str += '<p class="fz12 color9 ellipsis1">培训日期：<span>'+item.begintime+' ~ '+item.endtime+'</span></p>';
                	str += '<p class="fz12 color9 ellipsis1">培训进度：<span>'+studyplan+'%</span>&nbsp;<span class="colorBlue">[&nbsp;'+progressing+'&nbsp;]</span></p>';
                	str += '</div>';
                	str += '<div class="class-tab clearfix">';
                	str += '<p class="colorWhite xianshang fr">'+classType+'</p>';
                	str += '<p class="colorWhite mianfei fl">'+classCost+'</p>';
                	str += '</div>';
                	str += '<div class="progress" style="">';
                	str += '<div class="progress-bar progress-bar-success progress-bar-striped" role="progressbar" aria-valuenow="40" aria-valuemin="0" aria-valuemax="100" style="width: '+studyplan+'%">';
                	//str += '<span class="sr-only">40% Complete (success)</span>';
                	str += '</div>';
                	str += '</div>';
                	str += '</a>';
                	str += '<div class="far"></div>';
                	str += '</div>';
                }else if('lesson'==item.type){
					// 0 必修 1 选修
					if(item.lesson_type == 0) {
						lesson_type='必修';
					}
					if(item.lesson_type == 1) {
						lesson_type='选修';
					}

					// 是否免费 0：是 1：否
					if(item.isfree == 0) {
						isfree = '免费';
					}
					//收藏
					collectionamount = item.collectionamount;
					if(collectionamount==null||collectionamount==''){
						collectionamount = 0;
					}
					//点赞
					praiseamount = item.praiseamount;
					if(praiseamount==null||praiseamount==''){
						praiseamount = 0;
					}
					//评论
					evalcount = item.evalcount;
					if(evalcount==null||evalcount==''){
						evalcount = 0;
					}
					//点击
					browseamount = item.browseamount;
					if(browseamount==null||browseamount==''){
						browseamount = 0;
					}
					str += '<div class="col-sm-12 col-xs-12 forSelect">';
					str += '<a href="javascript:;" class="auto child">';
					str += '<div class="pic fl">';
					str += '<img src="../../images/demoPic.jpg" alt="" class="auto child"/>';
					str += '</div>';
					str += '<div class="listTxt">';
					str += '<h5 class="ellipsis2">'+item.le_name+'</h5>';
					str += '<div class="row-bottom">';
					str += '<p class="fz12 color9">学时：<span>'+item.hour+'学时</span></p>';
					str += '</div>';
					str += '</div>';
					str += '<div class="class-tab">';
					str += '<p class=" colorWhite bixiu">'+lesson_type+'</p>';
					str += '<p class=" colorWhite mianfei">'+isfree+'</p>';
					str += '</div>';
					str += '</a>';
					str += '<div class="clearfix classIco">';
					str += '<p class="col-sm-3 col-xs-3">';
					str += '<img src="../../images/classIco1.png" alt="">';
					str += '<span class="">收藏 (<b>'+collectionamount+'</b>)</span>';
					str += '</p>';
					str += '<p class=" col-sm-3 col-xs-3">';
					str += '<img src="../../images/classIco2.png" alt="">';
					str += '<span class="">点赞 (<b>'+praiseamount+'</b>)</span>';
					str += '</p>';
					str += '<p class=" col-sm-3 col-xs-3">';
					str += '<img src="../../images/classIco3.png" alt="">';
					str += '<span class="">评论 (<b>'+evalcount+'</b>)</span>';
					str += '</p>';
					str += '<p class=" col-sm-3 col-xs-3 text-right">';
					str += '<img src="../../images/classIco4.png" alt="">';
					str += '<span class="">点击量 (<b>'+browseamount+'</b>)</span>';
					str += '</p>';
					str += '</div>';
					str += '<div class="far"></div>';
					str += '</div>';
                }
                return str;
            }
            //学员名单
            function _createfaceMember(item){
                var str = "";
				str +='<li class="p10-15 bgWhite">';
				str +='<div class="person-intro p15-tb">';
				str +='<div class="pic fl">';
				/*if(item.photo!=null && item.photo!=""){
					str +='<img src="'+$.fn.getGKUrl()+"trainingclass/"+item.photo+'" alt="" class="child"/>';
				}else{
					str +='<img src="../../images/px-notice.png" alt="" class="child"/>';
				}*/
				str +='<img src="../../images/px-notice.png" alt="" class="child"/>';
				str +='</div>';
				str +='<div class="txt noPadding">';
				str +='<div class="name clearfix">';
				str +='<h6 class="color3 fzWeight fz16 fl">'+item.uname+'<span class="fz12 color9">'+(item.position==null?"":item.position)+'</span></h6>';
				str +='<div class="has-tip fl"></div>';
				str +='</div>';
				str +='<p class="jianjie text-justify color9 fz12 noPadding">'+(item.gname==null?"":item.gname)+'</p>';
				str +='</div>';
				str +='</div>';
				str +='</li>';
                //alert('str:'+str);
                return str;
            }
            //评论
            function _createfaceEvaluate(item){
            	var str = "";
            	str +='<li>';
				str +='<div class="person-intro p15-tb">';
				str +='<div class="pic fl">';
				/*if(item.photo!=null&&item.photo!=""){
					str +='<img src="'+$.fn.getGKUrl()+'traningclass/'+item.photo+'" alt="" class="child"/>';
				}else{
					str +='<img src="../../images/body-topSmall-bg.jpg" alt="" class="child"/>';
				}*/
				str +='<img src="../../images/body-topSmall-bg.jpg" alt="" class="child"/>';
				str +='</div>';
				str +='<div class="txt">';
				str +='<div class="name clearfix">';
				str +='<h6 class="color3 fz16 fl">'+item.name+'</h6>';
				str +='<div class="starNum fl" style="margin-left: 10px;">';
				for (var i = 1; i <= 5; i++) {
                    if (i <= item.score) {
                        str += '<span class="on"></span>';
                    } else {
                        str += '<span></span>';
                    }
                }
				str +='</div>';
				str +='</div>';
				str +='<p class="jianjie text-justify">'+item.content+'</p>';
				str +='<div class="date fz12 color6 text-right">'+item.updatetime+'</div>';
				str +='</div>';
				str +='</div>';
				str +='</li>';
            	//alert('str:'+str);
            	return str;
            }
}
//判断学时档案来源
    function getfrom_source(obj){
    	if (1==obj) {
    		obj='个人添加';
    	}else if (2==obj) {
    		obj='监管单位添加';
    	}else if (3==obj){
    		obj='公司添加';
    	}else {
    		obj='数据库无记录';
    	}
    	return obj;
    }
 function touchemoveFunction(e){e.preventDefault();}//禁用 touchmove
    document.addEventListener('touchmove', touchemoveFunction, false);
    document.addEventListener('DOMContentLoaded', loadScroller, false);
