﻿﻿﻿$(document).ready(function(event) {
	document.addEventListener("deviceready", onDeviceReady, false);
});
function onDeviceReady(){
	document.addEventListener("backbutton", eventBackButton, false);
}
function successFunction(){}
function failFunction(){}
/**
 * 获得得浏览器地址栏传值的方法
 *
 * 用法：$.fn.getQuery("name");
 * 例如地址栏地址为：1.html?name=张三&sex=男
 * $.fn.getQuery("name")取得的值为张三
 */
$.fn.getQuery = function(name) {
    var query = null;
    var search = window.location.search.substring(1);

    var args = search.split("&");
    for (var i = 0, length = args.length; i < length; i++) {
        var items = args[i].split("=");
        if (items[0] == name) {
            if (query == null) {
                query = decodeURI(items[1]);
            } else {
                query = "," + decodeURI(items[1]);
            }
        }
    }
    return query;
};
//APP名称
$.fn.getVersionName = "CBIRCAPP";
//APP版本
$.fn.getVersionCode = "V1.6.0";

function goAdmin(){
	var sheight = screen.height - 70;
	var swidth = screen.width - 10;
	$.ajax({
		url : $.fn.getServerUrl()+"login/getadminkey.do" ,
		type : "POST",
		dataType: "json",
		success : function(response) {
			if(response.success) {
				var winoption = "left=0,top=0,height=" + sheight + ",width=" + swidth + ",toolbar=yes,menubar=yes,location=yes,status=yes,scrollbars=yes,resizable=yes";
				var tmp = window.open("http://admin.cl-mlearning.com/admin/manager/index.do?_assertion="+response.key,"中国银行保险业网络学院" /*"国寿易学管理平台"*/, winoption);
				return tmp;
			}
		}
	});
}
//接口$.fn.getServerUrl();
$.fn.getServerUrl = function(){
	var origin = String( window.location.origin || window.location.protocol + "//" + window.location.hostname + ( window.location.port ? ':' + window.location.port : '' ) );
	//var url = origin + "/www/";
	/*测试环境*/
	//var url="http://118.190.114.116:8087/www/";
	/*内网环境*/
	//var url  = "http://172.16.35.133:8093/www/";
	/*本地环境*/
// var url  = "http://192.168.230.148:8070/CiitcMobileServices/";
	 /*联调环境*/
//      var url  = "http://106.38.93.94/www/";
      /*正式环境*/
   var url  = "https://learning.cbit.com.cn/www/";
 	return url;
};
//资源转换显示地址（pc，管理端显示）
$.fn.getGKUrl = function(){
	//var url = "http://10.0.0.121:8088/transformsouce/";
	//var url = "http://192.168.43.194/resource/";
//	var url = "http://106.38.93.94/resource/";
	var url = "https://learning.cbit.com.cn/resource/";
	return url;
};

$.fn.getDownload = function(){
	//var url = "http://10.0.0.121:8088/transformsouce/";
//	var url = "http://192.168.43.194/resource1/";
//	var url = "http://106.38.93.94/resource1/";
	var url = "https://learning.cbit.com.cn/resource1/";
	return url;
};
//接口$.fn.getServerUrl();
//$.fn.getServerUrl = function(){
//	//var url = "http://192.168.0.97:8080/www/";
//	var url = "http://192.168.50.107/ChinaLifeMobileServices/";
// 	return url;
//};
//回传接口url
$.fn.getBackServiceUrl = function(){
	//var url = "http://10.1.121.60:8080/ChinaLifeServices/";
	//var url = "http://192.168.0.139:8080/ChinaLifeMobileServices/";
//	var url = "http://192.168.43.194:8080/Transform/";
//var url = "http://106.38.93.94/Transform/";
	var url = "https://learning.cbit.com.cn/Transform/";
 	return url;
};

//培训班图片
$.fn.getTrainingClassUrl = function(){
	var url = "https://learning.cbit.com.cn/trainingclass/";
	return url;
};
//课件图片$.fn.getLessonPicture();
$.fn.getLessonPicture = function(){
	var url = "http://clgkresource.365yunxueyuan.com/lessonimg/";
	return url;
};
//人员头像$.fn.getPhotoUrl();
$.fn.getPhotoUrl = function(){
	var url = "http://clgkresource.365yunxueyuan.com/userimg/";
	return url;
};
//投票图片路径
$.fn.getVotePicture = function(){
	var url = "http://clgkresource.365yunxueyuan.com/vote/";
	return url;
};
//调查图片路径de_template
$.fn.getSurveyPicture = function(){
	var url = "http://clgkresource.365yunxueyuan.com/demand/";
	return url;
};
//考试图片路径
$.fn.getExamPicture = function(){
	var url = "http://clgkresource.365yunxueyuan.com/exam/";
	return url;
};
//图片$.fn.getPhotosUrl();
$.fn.getPhotosUrl = function(){
	var url = "http://clgkresource.365yunxueyuan.com/";
	return url;
};
//头条、热点图片路径
$.fn.getHotLinkUrl = function(){
	var url = "http://clgkresource.365yunxueyuan.com/hot/";
	return url;
};
//专栏图片路径
$.fn.getColumUrl = function(){
	var url = "http://clgkresource.365yunxueyuan.com/columnimg/";
	return url;
};
//徽章图片路径
$.fn.getBadgePicture = function(){
	var url = "http://clgkresource.365yunxueyuan.com/badge/";
	return url;
};
//更新地址
$.fn.getCheckVersion = function(){
//    var url = "http://106.38.93.94/www/";
	var url = "https://learning.cbit.com.cn/www/";
	return url;
};
//面授课讲师头像
$.fn.getFaceLesonTeacher = function(){
	var url = "http://clgkresource.365yunxueyuan.com/teacher_img/";
	return url;
};
//直播课图片$.fn.getLessonPicture();
$.fn.getLivePicture = function(){
	var url = "http://clgkresource.365yunxueyuan.com/liveHomeimg/";
	return url;
};
$.fn.getGensee = function(){
	var url = "?nickname=1471551966@qq.com&loginPassword=12345678&token=";
	return url;
};
/**
   *  适应iphoneX添加meta
   *
   */
  $(function (){

  	  var head = document.getElementsByTagName('head').item(0);
  	  var meta1 =document.createElement('meta');
  	  meta1.name='viewport';
  	  meta1.content="width=device-width,initial-scale=1.0,viewport-fit=cover";
  	  head.appendChild(meta1);

  })